Index: trunk/src/ws2_32/socket.cpp
===================================================================
--- trunk/src/ws2_32/socket.cpp	(revision 9834)
+++ trunk/src/ws2_32/socket.cpp	(revision 9836)
@@ -1,3 +1,3 @@
-/* $Id: socket.cpp,v 1.13 2002-05-06 09:38:52 sandervl Exp $ */
+/* $Id: socket.cpp,v 1.14 2003-02-22 10:05:41 sandervl Exp $ */
 /*
  * based on Windows Sockets 1.1 specs
@@ -149,19 +149,65 @@
                        return cs;
                case CF_DEFER:
-                       SetLastError(WSATRY_AGAIN);
+                       WSASetLastError(WSATRY_AGAIN);
                        return SOCKET_ERROR;
                case CF_REJECT:
                        closesocket(cs);
-                       SetLastError(WSAECONNREFUSED);
+                       WSASetLastError(WSAECONNREFUSED);
                        return SOCKET_ERROR;
                default:
                        FIXME("Unknown return type from Condition function\n");
-                       SetLastError(WSAENOTSOCK);
+                       WSASetLastError(WSAENOTSOCK);
                        return SOCKET_ERROR;
                }
 
-       SetLastError(WSAENOTSOCK);
+       WSASetLastError(WSAENOTSOCK);
        return SOCKET_ERROR;
 }
 //******************************************************************************
 //******************************************************************************
+/***********************************************************************
+ *		WSASendTo		(WS2_32.74)
+ */
+INT WINAPI WSASendTo( SOCKET s, LPWSABUF lpBuffers, DWORD dwBufferCount,
+                      LPDWORD lpNumberOfBytesSent, DWORD dwFlags,
+                      const struct WS_sockaddr *to, int tolen,
+                      LPWSAOVERLAPPED lpOverlapped,
+                      LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine )
+{
+    WSASetLastError(WSAENOTSOCK);
+    return SOCKET_ERROR;
+}
+/***********************************************************************
+ *		WSASend			(WS2_32.72)
+ */
+INT WINAPI WSASend( SOCKET s, LPWSABUF lpBuffers, DWORD dwBufferCount,
+                    LPDWORD lpNumberOfBytesSent, DWORD dwFlags,
+                    LPWSAOVERLAPPED lpOverlapped,
+                    LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine )
+{
+    return WSASendTo ( s, lpBuffers, dwBufferCount, lpNumberOfBytesSent, dwFlags,
+                       NULL, 0, lpOverlapped, lpCompletionRoutine );
+}
+/***********************************************************************
+ *              WSARecvFrom             (WS2_32.69)
+ */
+INT WINAPI WSARecvFrom( SOCKET s, LPWSABUF lpBuffers, DWORD dwBufferCount,
+                        LPDWORD lpNumberOfBytesRecvd, LPDWORD lpFlags, struct WS_sockaddr *lpFrom,
+                        LPINT lpFromlen, LPWSAOVERLAPPED lpOverlapped,
+                        LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine )
+
+{
+    WSASetLastError(WSAENOTSOCK);
+    return SOCKET_ERROR;
+}
+/***********************************************************************
+ *		WSARecv			(WS2_32.67)
+ */
+int WINAPI WSARecv (SOCKET s, LPWSABUF lpBuffers, DWORD dwBufferCount,
+		    LPDWORD NumberOfBytesReceived, LPDWORD lpFlags,
+		    LPWSAOVERLAPPED lpOverlapped,
+		    LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine)
+{
+    return WSARecvFrom (s, lpBuffers, dwBufferCount, NumberOfBytesReceived, lpFlags,
+                        NULL, NULL, lpOverlapped, lpCompletionRoutine);
+}
Index: trunk/src/ws2_32/ws2_32.def
===================================================================
--- trunk/src/ws2_32/ws2_32.def	(revision 9834)
+++ trunk/src/ws2_32/ws2_32.def	(revision 9836)
@@ -1,3 +1,3 @@
-; $Id: ws2_32.def,v 1.13 2002-08-16 15:30:41 sandervl Exp $
+; $Id: ws2_32.def,v 1.14 2003-02-22 10:05:41 sandervl Exp $
 
 ;Created by BLAST for IBM's compiler
@@ -118,12 +118,12 @@
 ; WSANtohs                                         @65
 ; WSAProviderConfigChange                          @66
-; WSARecv                                          @67
+  WSARecv            = _WSARecv@28                 @67
 ; WSARecvDisconnect                                @68
-; WSARecvFrom                                      @69
+  WSARecvFrom        = _WSARecvFrom@36             @69
 ; WSARemoveServiceClass                            @70
   WSAResetEvent      = _ResetEvent@4               @71
-; WSASend                                          @72
+  WSASend            = _WSASend@28                 @72     
   WSASendDisconnect  = _WSASendDisconnect@8        @73
-; WSASendTo                                        @74
+  WSASendTo          = _WSASendTo@36               @74
   WSASetEvent        = _WSASetEvent@4              @75
 ; WSASetServiceA                                   @76